import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.Random;
import java.util.Scanner;

public class Client {
	static Socket socket;
	static DataInputStream in;
	static DataOutputStream out;
	
	public static void main(String[] args) throws Exception {
		System.out.println("Enter the IP address you want to connect");
		Scanner scan = new Scanner(System.in);
		String IP = scan.nextLine();
		System.out.println("Connecting");
		socket = new Socket(IP,9999);
		System.out.println("Connection Successful");
		in = new DataInputStream(socket.getInputStream());
		out = new DataOutputStream(socket.getOutputStream());
		Input input = new Input(in);
		Thread thread = new Thread(input);
		thread.start();
		Scanner sc = new Scanner(System.in);
		System.out.print("Enter you name and press enter :");
		String name = sc.nextLine();
		out.writeUTF(name);
		while(true) {
			
			String sendMessage = sc.nextLine();
			out.writeUTF(encryptMessage(sendMessage));
		}
	}

	private static String encryptMessage(String sendMessage) {
		int mid ;
		String newMessage = "";
		if(sendMessage.length()%2 != 0) {
			mid = (sendMessage.length()/2) +1;
		} else {
			mid = (sendMessage.length()/2);
		}
		for(int i = mid; i < sendMessage.length();i++) {
			newMessage = newMessage + sendMessage.charAt(i);
		}
		if(sendMessage.length()%2 != 0) {
			newMessage = newMessage + sendMessage.charAt(sendMessage.length()/2);
			for(int i = 0; i < mid-1;i++) {
				newMessage = newMessage + sendMessage.charAt(i);
			}
		} else {
			for(int i = 0; i < mid;i++) {
				newMessage = newMessage + sendMessage.charAt(i);
			}
		}
		
		return changeKey(newMessage);
		
		
	}

	private static String changeKey(String newMessage) {
		String changedKey ="";
		for(int i = 0 ; i < newMessage.length(); i++) {
			if(newMessage.charAt(i) == 'A') {
				changedKey = changedKey + "1";
			}else if(newMessage.charAt(i) == 'E') {
				changedKey = changedKey + "2";
			}else if(newMessage.charAt(i) == 'I') {
				changedKey = changedKey + "3";
			}else if(newMessage.charAt(i) == 'O') {
				changedKey = changedKey + "4";
			}else if(newMessage.charAt(i) == 'U') {
				changedKey = changedKey + "5";
			}else if(newMessage.charAt(i) == 'a') {
				changedKey = changedKey + "6";
			}else if(newMessage.charAt(i) == 'e') {
				changedKey = changedKey + "7";
			}else if(newMessage.charAt(i) == 'i') {
				changedKey = changedKey + "8";
			}else if(newMessage.charAt(i) == 'o') {
				changedKey = changedKey + "9";
			}else if(newMessage.charAt(i) == 'u') {
				changedKey = changedKey + "*";
			}else {
				changedKey = changedKey + newMessage.charAt(i);
			}
		}
		return changedKey;
	}
}

class Input implements Runnable {
	
	DataInputStream in;
	public Input(DataInputStream in) {
		this.in = in;
	}
	public void run() {
		while(true) {
			try {
				String message = in.readUTF();
				System.out.println(" **********************");
				System.out.println("Received Message from " + message);
				System.out.println(" **********************");
				System.out.println(" ------------------------------");
				System.out.println(decryptMessage(message));
				System.out.println(" ------------------------------");
			} catch (IOException e) {
				
				System.out.println("You have disconnected");
			}
			
		}
		
	}
	private String decryptMessage(String message) {
		String newMessage = "";
		String encryptedword = "";
		int i = 0;
		while(message.charAt(i) != ':') {
			newMessage = newMessage + message.charAt(i);
			i++;
		}
		newMessage = newMessage + message.charAt(i);
		i++;
		
		while(i < message.length()) {
			encryptedword = encryptedword + message.charAt(i);
			i++;
		}
		int mid ;
		
		if(encryptedword.length()%2 != 0) {
			mid = (encryptedword.length()/2) +1;
			
		} else {
			mid = (encryptedword.length()/2);
		}
		for(int j = mid; j < encryptedword.length();j++) {
			newMessage = newMessage + encryptedword.charAt(j);
		}
		if(encryptedword.length()%2 != 0) {
			newMessage = newMessage + encryptedword.charAt(encryptedword.length()/2);
			for(int k = 0; k < mid-1;k++) {
				newMessage = newMessage + encryptedword.charAt(k);
			}
		}
		else {
			for(int k = 0; k < mid;k++) {
				newMessage = newMessage + encryptedword.charAt(k);
			}
		}
		
		
		return changeDecrypt(newMessage) ;
	}
	
	private String changeDecrypt(String newMessage) {
		String changeKey = "";
		for (int i = 0; i < newMessage.length(); i++) {
			if (newMessage.charAt(i) == '1') {
				changeKey = changeKey +"A";
			} else if (newMessage.charAt(i) == '2') {
				changeKey = changeKey + "E";
			} else if (newMessage.charAt(i) == '3') {
				changeKey = changeKey + "I";
			} else if (newMessage.charAt(i) == '4') {
				changeKey = changeKey + "O";
			}  else if (newMessage.charAt(i) == '5') {
				changeKey = changeKey + "U";
			} else if (newMessage.charAt(i) == '6') {
				changeKey = changeKey + "a";
			} else if (newMessage.charAt(i) == '7') {
				changeKey = changeKey + "e";
			} else if (newMessage.charAt(i) == '8') {
				changeKey = changeKey + "i";
			} else if (newMessage.charAt(i) == '9') {
				changeKey = changeKey + "o";
			} else if (newMessage.charAt(i) == '*') {
				changeKey = changeKey + "u";
			} else {
				changeKey = changeKey + newMessage.charAt(i);
			}
		}
		return changeKey;
	}
	

}

